# THIRD プログラミングコンテスト 2021 抽選プログラム
# プログラム内のパラメータを変更した上でPython3上で実行します。
# 環境依存はなるべく発生しない様に作成したつもりですが、主催者環境での動作結果を正とします。

import random

# 正の点数を取った人の人数を入力するために、ゼロ点の人の順位を入力する方が楽です。
scoreZeroRank = 1001
submitterCount = scoreZeroRank - 1

# 上位3名分のスコアを入れます。4位以下のスコアは無視されます。
topScores = [100, 90, 80, 70, 60, 50, 40, 30, 20, 10]

# ここより上のパラメータを変更した上で実行します。

# 固定
prizes = [
    (1, 50000),
    (2, 30000),
    (3, 20000),
    (4, 10000),
] + [(-1, 3000)] * 30


def lottery(topScores, submitterCount, prizes):
    scoreSum = sum(int(score) for score in topScores[:3])
    rng = random.Random(scoreSum)
    already = {rank for rank, amount in prizes if 0 < rank}
    lots = [(1000000 // rank, rank) for rank in range(1, submitterCount+1) if rank not in already]
    for index, (rank, amount) in enumerate(prizes):
        if 0 <= rank:
            continue
        sum_weights = sum(weight for weight, rank in lots)
        R = rng.randrange(sum_weights)
        for i, (weight, rank) in enumerate(lots):
            if R < weight:
                prizes[index] = (rank, ) + prizes[index][1:]
                lots.pop(i)
                break
            R -= weight


if __name__ == "__main__":
    lottery(topScores, submitterCount, prizes)

    prizes.sort()

    totalAmount = 0
    for rank, amount in prizes:
        print(f'{rank}位: {amount}円分Amazonギフト券')
        totalAmount += amount
    print()
    print(f'総額: {totalAmount}円分Amazonギフト券')
